//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unitrs232.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

int len;
char *sendcom,*reccom;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void ShowLastError(AnsiString where)
{
MessageBox(NULL,SysErrorMessage(GetLastError()).c_str(),
where.c_str(),MB_OK|MB_ICONERROR);
}



HANDLE OpenComm(char* Port) { // ffnet den Port und gibt ein Handle zurck
HANDLE hCom = CreateFile(Port,// z.B. "COM1",
     GENERIC_READ|GENERIC_WRITE,//zum Senden und Empfangen
     0, // Fr comm devices exclusive-access notwendig
     0, // Keine security attributes
     OPEN_EXISTING, // Fr comm devices notwendig
     0, // Kein overlapped I/O
     0); // Fr comm devices muss hTemplate NULL sein
if (hCom == INVALID_HANDLE_VALUE)
       ShowLastError("CreateFile: "+AnsiString(Port));
return hCom;
}

HANDLE hComSend,hComReceive;


DWORD ReceiveData(char* Data,int n)
{
DWORD NumberOfBytesRead; // Anzahl der gelesenen Bytes
   bool b=ReadFile(hComReceive, // handle des Com-Ports
     Data, // Adresse des Datenpuffers
     n, // Anzahl der zu lesenden Bytes
     &NumberOfBytesRead, // Adresse bergeben
     0); // kein overlapped I/O
   if (!b) ShowLastError("ReadFile");
return NumberOfBytesRead;
}

void SetDCB(HANDLE hCom)
{
DCB dcb; // Device Control Block
  BOOL fSuccess = GetCommState(hCom, &dcb); // DCB lesen
   if (!fSuccess) ShowLastError("GetCommState");
     dcb.BaudRate = StrToInt(Form1->ComboBox1->Text); // Baudrate
     dcb.ByteSize = 8; // 8 Datenbits
     dcb.Parity = NOPARITY; // keine Parity
     dcb.StopBits = ONESTOPBIT; // 1 Stopbit
     // SetCommState konfiguriert die serielle Schnittstelle
  fSuccess = SetCommState(hCom, &dcb);
  if (!fSuccess) ShowLastError("SetCommState");
}


void SetReadTimeouts(HANDLE hCom)
{
COMMTIMEOUTS t;
// Alle Wert in Millisekunden
// Werte fr ReadFile:
   t.ReadIntervalTimeout=100; // Zeit zwischen zwei Zeichen
   t.ReadTotalTimeoutMultiplier=0; // pro Zeichen
   t.ReadTotalTimeoutConstant=1;
     // Werte fr WriteFile: wenn beide 0 sind, kein Timeout
     // beim Schreiben
   t.WriteTotalTimeoutMultiplier=0;
   t.WriteTotalTimeoutConstant=0;
 if (!SetCommTimeouts(hCom,&t)) ShowLastError("SetCommTimeouts");
}


int SendData(char Data[],int n)
{
DWORD NumberOfBytesWritten; //Anzahl der gesendeten Bytes
  bool b=WriteFile(hComSend, // handle des Com-Ports
     Data, // Adresse der Daten
     n, // Anzahl der zu sendenden Bytes
     &NumberOfBytesWritten, // Adresse bergeben
     0); // kein overlapped I/O
  if (!b) ShowLastError("WriteFile");
return NumberOfBytesWritten;
}


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
const int BufSize = 100;
int i;
char Buffer[BufSize]; // Puffer fr die empfangenen Daten
  DWORD NumberOfBytesRead=ReceiveData(Buffer,BufSize);
  if (NumberOfBytesRead > 0)
    {
      AnsiString s,shex;
      for (DWORD i=0;i<NumberOfBytesRead;i++)
      {
        shex=shex+IntToHex(Buffer[i],2)+" "; //Ausgabe in Hex
        s=s+Buffer[i];      // Ausgabe in ASCII
      }  
      Memo1->Lines->Add("Gelesen n="+IntToStr(NumberOfBytesRead)+" ch="+s);

      Edit3->Text=shex; // Aktuelle Zeile
      }
      // else
      //    Memo1->Lines->Add("Nichts empfangen");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BSendenClick(TObject *Sender)
{
AnsiString send;
char CR=0x0d;
send=Edit1->Text+CR;
int n=SendData(send.c_str(),send.Length());
Memo1->Lines->Add("Written: "+IntToStr(n));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButStartEmpfangClick(TObject *Sender)
{
if (Timer1->Enabled) Timer1->Enabled=false; else Timer1->Enabled=true;
if (Timer1->Enabled) ButStartEmpfang->Caption= "Stop Empfang";
      else ButStartEmpfang->Caption= "Start Empfang";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButGetConfClick(TObject *Sender)
{
 DCB dcb; // Device Control Block
   BOOL fSuccess = GetCommState(hComSend, &dcb); // DCB lesen
   if (!fSuccess) ShowLastError("GetCommState");
   Label1->Caption="Baudrate:  "+IntToStr (dcb.BaudRate); // Baudrate
   Label2->Caption="Datenbit:  "+IntToStr (dcb.ByteSize); // Datenbits
   switch (dcb.Parity)  {
     case EVENPARITY  :Label3->Caption="Parity Even" ;break;
     case MARKPARITY  :Label3->Caption="Parity Mark" ;break;
     case NOPARITY    :Label3->Caption="Parity No" ;break;
     case ODDPARITY   :Label3->Caption="Parity Odd" ;break;
    }
    switch (dcb.StopBits)  {
     case ONESTOPBIT    :Label4->Caption="Stopbit 1" ;break;
     case ONE5STOPBITS  :Label4->Caption="Stopbit 1.5" ;break;
     case TWOSTOPBITS   :Label4->Caption="Stopbit 2" ;break;
    }



}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButSetConfClick(TObject *Sender)
{  // SET Config
 SetDCB(hComSend);
 SetDCB(hComReceive);
 ButGetConfClick(Sender);// Zeige neue Konfiguration
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
Memo1->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup2Click(TObject *Sender)
{
 if (RadioGroup2->ItemIndex==0) // COM1
      sendcom="COM1" ; else sendcom="COM2" ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   hComSend=OpenComm(sendcom);  //
   if (RadioGroup2->ItemIndex==RadioGroup1->ItemIndex )
            hComReceive=hComSend;
       else hComReceive=OpenComm(reccom);  // Wenn mit kurzschlusskabel auf gleichem
    // Com-Port gesendet wie empfangen wird (Pin 2 und Pin3 kurz)
    //Setze COM1 und COM2 auf dieselben bertragungsparameter
   //SetDCB(hComSend);
   //SetDCB(hComReceive);
   SetReadTimeouts(hComReceive);
   Button3->Enabled=false;
   ButGetConf->Enabled=true;
   ButSetConf->Enabled=true;
   ButStartEmpfang->Enabled=true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
if (RadioGroup1->ItemIndex==0) reccom="COM1" ; else reccom="COM2" ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
sendcom="COM2";reccom="COM2";        
}
//---------------------------------------------------------------------------


